#!/usr/bin/env python
"""
@File  : reset_issend_to_zero.py
@Author: DJW
@Date  : 2023-06-13 14:35:14
@Desc  : 重新设置某个时间段is_send为0，为了重新打包上传历史数据
"""
import time
import configparser
import LogOut

from mysqlDataBase import MysqldbOperational

if __name__ == "__main__":
    _logger = LogOut.Log('reset_issend_to_zero')
    # 创建读取配置文件对象
    config = configparser.ConfigParser()
    config.read("config.ini", encoding="utf-8")
    # 获取通用配置项
    # section = "General"  # 读取的部section标签
    mysql_host = "localhost"
    mysql_username = "root"
    mysql_password = "R.!a@O&t9CjweWLSTr"
    mysql_port = 3306
    mysql_database = "centralized_control_db"
    # 连接数据库
    my = MysqldbOperational(
        host=mysql_host,
        username=mysql_username,
        password=mysql_password,
        port=mysql_port,
        database=mysql_database,
        logger=_logger)

    dates = ["2023-01-06", "2023-01-07", "2023-01-25", "2023-02-14", "2023-02-15", "2023-03-02", "2023-03-03",
         "2023-03-04", "2023-03-05", "2023-03-06", "2023-03-30", "2023-03-31", "2023-05-16", "2023-05-17",
         "2023-05-18", "2023-05-19"]

    # 查询含有is_send字段的数据表
    sql = f"SELECT TABLE_NAME from INFORMATION_SCHEMA.columns " \
          f"WHERE TABLE_NAME LIKE 'table_%' AND COLUMN_NAME = 'is_send' AND table_schema = '{mysql_database}';"
    result = my.executeSql(sql)
    if result:
        table_names = [i[0] for i in result]
        # 遍历表名和需要is_send置0的日期,更新置0
        for table_name in table_names:
            for date in dates:
                try:
                    sql = f"UPDATE `{table_name}` SET is_send=0 WHERE times BETWEEN '{date} 00:00:00' AND '{date} 23:59:59';"
                    my.executeCommit(sql)
                except Exception as e:
                    _logger.error(e)
                print(f"【{table_name}】已经完成置0 sql：{sql}")
